<template>
  <div class="aselect" v-click-outside="hideSelect" :data-value="valueLocal" :data-list="list">
    <div class="selector" @click="toggle" ref="id1">
      <div class="label" ref="id2">
        <span>{{ valueLocal }}</span>
      </div>
      <div class="arrow" :class="{ expanded : visible }"></div>
      <div v-if="visible" :class="{ hidden : !visible, visible }">
        <ul
          :class="{top: top}"
          :style="{
            top: positionList + 'px'
          }"
        >
          <li :class="{ current : item === valueLocal }" v-for="(item, i) in list" :key="'vSelect'+i" @click="select(item)">{{ item }}</li>
        </ul>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "v-select",
  data () {
    return {
      visible: false,
      valueLocal: this.value,
      topLocal: this.top
    }
  },
  props: {
    value: String,
    list: Array,
    top: Boolean
  },
  computed: {
    positionList () {
      if (this.topLocal) return this.list.length * -42 + 1
      else return false
    }
  },
  watch: {
    valueLocal () {
      this.visible = false
    }
  },
  methods: {
    toggle(el) {
      if (this.visible) {
        if (this.$refs.id1 === el.target.parentElement || this.$refs.id2 === el.target.parentElement) this.hideSelect()
      } else this.visible = true
    },
    select(option) {
      this.valueLocal = option;
    },
    hideSelect () {
      this.visible = false
    }
  },
  mounted () {
    // document.addEventListener('click', this.hideSelect.bind(this), true)
  },
  beforeDestroy () {
    // document.removeEventListener('click', this.hideSelect)
  }
}
</script>

<style scoped lang="scss">
.aselect {
  margin: 0 auto;
  .selector {
    border: 2px solid #97C1F2;
    background: #F8F8F8;
    position: relative;
    box-sizing: border-box;
    border-radius: 12px;
    width: 100%;
    .arrow {
      position: absolute;
      right: 15px;
      top: 23%;
      width: 23px;
      height: 22px;
      background: url("../assets/images/icons/select-arrow.svg");
      background-size: cover;
      transform: rotateZ(0deg) translateY(0px);
      transition-duration: 0.3s;
      transition-timing-function: cubic-bezier(.59,1.39,.37,1.01);
    }
    .expanded {
      transform: rotateZ(180deg) translateY(2px);
    }
    .label {
      display: block;
      padding: 12px;
      font-size: 16px;
      color: #888;
    }
  }
  ul {
    width: 96%;
    list-style-type: none;
    padding: 0;
    margin: 0;
    font-size: 16px;
    position: absolute;
    left: 1.5%;
    background: #fff;
    z-index: 994;
    border: 2px solid #97C1F2;
    box-sizing: border-box;
    border-radius: 0 0 12px 12px;
    overflow: hidden;
    &.top {
      border-radius: 12px 12px 0 0;
      border-bottom: 0;
    }
  }
  li {
    padding: 12px;
    height: 40px;
    color: #666;
    &:hover {
      color: white;
      background: #2B7FE2;
    }
  }
  .current {
    background: #eaeaea;
  }
  .hidden {
    visibility: hidden;
  }
  .visible {
    visibility: visible;
  }
}
</style>
